/*
        Maintened by *Edwards
        For FantasiaShard.com

        Edwards@FantasiaShard.com

        2009-10-10
*/

function EnterSleepMode()

	if( !sleep_mode )
		if( g_scripts["Sleep"] )
			var process := GetNerveProcess( npc, "Sleep" );
			if( !process )
				StartNerve( npc, "Sleep", g_scripts["Sleep"].script, array{g_settings, g_scripts}, g_scripts["Sleep"].flags );
			endif
		else
			foreach nerve in ( LoadNerves( npc ))
				if( nerve.flags & NF_CONTINUE_ON_SLEEP )
					continue;
				else
					StopNerve( npc, _nerve_iter );
				endif
    
				SleepMS(2);
			endforeach
		endif
	
		sleep_mode := 1;
	endif
	
	return 1;
endfunction

function LeaveSleepMode()

	if( sleep_mode )
		StopNerve( npc, "Sleep" );
	endif

	if( g_scripts.Exists( "LookAround" ))
		if( !GetNerveProcess( npc, "LookAround" ))
			StartNerve( npc, "LookAround", g_scripts["LookAround"].script, array{g_settings, g_scripts}, g_scripts["LookAround"].flags );
		endif
	endif
	
	idle_ticks := 0;
	sleep_mode := 0;

	return 1;
endfunction

function ShouldSleep()

	if( sleep_mode )
		// Already asleep.
		return 0;
	elseif( Events_Waiting() )
		// Events are waiting to process.
		return 0;
	elseif( g_settings["NoSleep"] )
		// NPC is not allowed to enter sleep mode.
		return 0;
        elseif( GetObjProperty( npc, "MustSleep" ))
		return 1;
	elseif( GetNerveProcess( npc, "LookAround" ))
		// Look around script is currently running.
		return 0;
	elseif( idle_ticks < g_settings["IdleTicks"] )
		// Not enough idle ticks have gone by yet.
		return 0;
	endif
	
	return 1;
endfunction
